#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h> /* standard system data types. */
#include <sys/ipc.h> /* common system V IPC structures. */
#include <sys/msg.h> /* message-queue specific functions. */

typedef struct {
	long mtype; /* type of received/send message */
	char mtext[70]; /* text of the message */
} MSGBUF;

float pi=0;
int msgid;

void Handler_Ch(int a)
{
	MSGBUF msg;
	signal(SIGUSR1, Handler_Ch);
	msg.mtype = 1;
	sprintf(msg.mtext, "%.67f", pi);
	// no flag set
	int rc = msgsnd(msgid, &msg, sizeof(msg.mtext), 0);
	if (rc == -1) {
		perror("child 1 msgsnd");
		exit(1);
	}
}

void compute_pi1()
{
	float counter=1;
	int flag=0;
	signal(SIGINT, SIG_IGN);
	signal(SIGTSTP, SIG_IGN);
	signal(SIGUSR1, Handler_Ch);
	while(1)
	{
		if (flag % 2==0)
			pi= pi+(4/counter);
		else
			pi= pi-(4/counter);
		flag++;
		counter+=2;
		sleep(1);
	}
}

int main()
{
	msgid = msgget(10, IPC_CREAT | 0400);
        if (msgid == -1) {
                perror("msgget in child 1 failed");
                exit(EXIT_FAILURE);
        }
	compute_pi1();
}
